<script setup lang="ts">
  const props = withDefaults(
    defineProps<{
      modelValue?: number;
      packUnit?: string;
      maxPurchase?: number;
      minPurchase?: number;
      purchaseSteps?: number;
      readonly?: boolean;
    }>(),
    {
      modelValue: 0,
      packUnit: undefined,
      purchaseSteps: 1,
      minPurchase: 1,
      maxPurchase: undefined,
      readonly: false,
    },
  );

  const $quantityInput = ref<HTMLInputElement>();
  const emit = defineEmits(['update:modelValue']);

  const quantity = ref(props.minPurchase);
  syncRefs(toRef(props, 'modelValue'), quantity);

  const stepUp = () => {
    $quantityInput.value?.stepUp();
    $quantityInput.value?.dispatchEvent(new Event('input'));
  };

  const stepDown = () => {
    $quantityInput.value?.stepDown();
    $quantityInput.value?.dispatchEvent(new Event('input'));
  };

  const onChangeDebounced = useDebounceFn(() => {
    const value = $quantityInput.value?.value;
    if (props.readonly || !value) return;
    emit('update:modelValue', Number(value));
  }, 500);

  const onBlur = () => {
    if (props.readonly) return;
    const quantityInputValue = $quantityInput.value?.value;
    quantityInputValue ||
      ($quantityInput.value && ($quantityInput.value.value = props.modelValue.toString()));
  };
</script>
<template>
  <div class="flex h-full" :class="packUnit ? 'aspect-[4/1]' : 'aspect-[3/1]'">
    <slot name="minus-button">
      <SwButton
        variant="action"
        class="max-w-10 rounded-l-md rounded-r-none !p-0"
        :class="packUnit ? 'min-w-1/4' : 'min-w-1/3'"
        :disabled="readonly || modelValue <= minPurchase"
        @click="stepDown"
      >
        <span class="i-sw-regular:minus-xxs text-2xl" />
      </SwButton>
    </slot>
    <slot name="quantity">
      <input
        ref="$quantityInput"
        :value="quantity"
        class="border-(x-none border) text-(sm center) focus:(border-border ring-0) flex w-12 flex-1 cursor-default items-center justify-center p-0 shadow outline-none"
        :class="packUnit ? 'min-w-1/4' : 'min-w-1/3'"
        type="number"
        :min="minPurchase"
        :max="maxPurchase"
        :step="purchaseSteps"
        :disabled="readonly"
        @input="onChangeDebounced"
        @blur="onBlur"
      />
    </slot>
    <slot name="plus-button">
      <SwButton
        variant="action"
        class="max-w-10 rounded-l-none !p-0"
        :class="packUnit ? 'min-w-1/4 rounded-r-none' : 'min-w-1/3 rounded-r-md'"
        :disabled="readonly || (maxPurchase && modelValue + purchaseSteps > maxPurchase)"
        @click="stepUp"
      >
        <span class="i-sw-regular:plus-xxs text-2xl" />
      </SwButton>
    </slot>
    <slot name="pack-unit">
      <SwButton
        v-if="packUnit"
        variant="action"
        class="bg-background-raised rounded-l-none rounded-r-md"
      >
        {{ packUnit }}
      </SwButton>
    </slot>
  </div>
</template>

<style scoped>
  input[type='number']::-webkit-outer-spin-button,
  input[type='number']::-webkit-inner-spin-button,
  input[type='number'] {
    -webkit-appearance: none;
    -moz-appearance: textfield !important;
    margin: 0;
  }
</style>
